;(c) S Walter 2015
#include <GDIPlus.au3>
#include <WindowsConstants.au3>

$iW = @DesktopWidth
$iH = @DesktopHeight

$hWnd = GUICreate("", $iW, $iH, 0, 0, $WS_POPUP, $WS_EX_TOPMOST)
GUISetCursor(16)
GUISetState()

_GDIPlus_Startup()

$hGraphics = _GDIPlus_GraphicsCreateFromHWND($hWnd)
$hBufferBitmap = _GDIPlus_BitmapCreateFromGraphics($iW, $iH, $hGraphics)
$hBuffer = _GDIPlus_ImageGetGraphicsContext($hBufferBitmap)

_GDIPlus_GraphicsSetSmoothingMode($hGraphics, 2)
_GDIPlus_GraphicsSetSmoothingMode($hBuffer, 2)

$hImage = _GDIPlus_BitmapCreateFromFile("Bee.png")

$iX = 0
$nDeg2Rad = (3.1415 / 180)

While True
	_GDIPlus_GraphicsClear($hBuffer, 0xFF00FF00)

	_GDIPlus_DrawImageRotate($hBuffer, $hImage, $iX, GetPosBySin($iX), GetAngle($iX))
	$iX += 5
	If $iX >= $iW Then $iX = 0

	_GDIPlus_GraphicsDrawImage($hGraphics, $hBufferBitmap, 0, 0)
	If GUIGetMsg() = -3 Then Exit
WEnd


Func GetPosBySin($iX)
	Return Sin($iX * (3.1415 / 180)) * ($iH / 4) + ($iH / 2)
EndFunc

Func GetAngle($iX)
	; (sin(x))'=cos(x)
	$nAbl = Cos($iX * (3.1415 / 180)) * Sqrt(2)
	$nDeg = ATan($nAbl) * (180 / 3.1415)
	Return $nDeg
EndFunc

Func _GDIPlus_DrawImageRotate($hGraphics, $hImage, $iX, $iY, $nAngle)
	;chesstiger
	Local $nPi, $nDeg2Rad, $nAngleRad, $iW, $iH, $aP[6]

	$nPi = ACos(-1)
	$nDeg2Rad = ($nPi / 180)
	$nAngleRad = $nAngle * $nDeg2Rad
	$iW = _GDIPlus_ImageGetWidth($hImage)
	$iH = _GDIPlus_ImageGetHeight($hImage)

	$aP[0] = $iX
	$aP[1] = $iY
	$aP[2] = $iX + Cos($nAngleRad) * $iW
	$aP[3] = $iY + Sin($nAngleRad) * $iW
	$aP[4] = $iX + Cos($nAngleRad + $nPi / 2) * $iH
	$aP[5] = $iY + Sin($nAngleRad + $nPI / 2) * $iH

	_GDIPlus_DrawImagePoints($hGraphics, $hImage, $aP[0], $aP[1], $aP[2], $aP[3], $aP[4], $aP[5])
EndFunc